/*	reduce.h

	AFAPI associative reduction function declarations.

	July 1996 by H. Dietz
*/


#ifndef _P_REDUCE_H
#define _P_REDUCE_H


#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceAnd##suffix(register p_##suffix datum);
P_BETA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceOr##suffix(register p_##suffix datum);
P_BETA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceXor##suffix(register p_##suffix datum);
P_BETA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceMin##suffix(register p_##suffix datum);
P_ALPHA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceMax##suffix(register p_##suffix datum);
P_ALPHA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceAdd##suffix(register p_##suffix datum);
P_GAMMA

#undef	P_DECLARE

#define	P_DECLARE(suffix) \
extern p_##suffix \
p_reduceMul##suffix(register p_##suffix datum);
P_GAMMA

#undef	P_DECLARE


#endif
